]> git.pld-linux.org Git - packages/percona-server.git/blob - mysql.init
- symbolic-links=0 from fedora
[packages/percona-server.git] / mysql.init
1 #!/bin/sh
2 #
3 # mysql         A very fast and reliable SQL database engine
4 #
5 # chkconfig:    2345 84 25
6 #
7 # description:  A very fast and reliable SQL database engine.
8 #
9 # $Id$
10
11 # Source function library
12 . /etc/rc.d/init.d/functions
13
14 # Get network config
15 . /etc/sysconfig/network
16
17 # Get service config
18 if [ -f /etc/sysconfig/mysql ]; then
19         . /etc/sysconfig/mysql
20 else
21         nls "Error: %s not found" /etc/sysconfig/mysql
22         nls "%s can't be run." MySQL
23         exit 1
24 fi
25
26 if [ -n "$MYSQL_DB_CLUSTERS" ]; then
27         nls "Warning: MYSQL_DB_CLUSTERS is set. It's obsolete. Use %s instead." /etc/mysql/clusters.conf
28 fi
29
30 if [ -f /etc/mysql/clusters.conf ]; then
31         MYSQL_DB_CLUSTERS=$(awk -F= '!/^#/ && /=/{print $2}' /etc/mysql/clusters.conf)
32         if [ -z "$MYSQL_DB_CLUSTERS"  ]; then
33                 nls "Warning: there are no configured clusters."
34         fi
35
36 else
37         nls "Warning: Missing clusters config file %s" /etc/mysql/clusters.conf
38         if [ -z "$MYSQL_DB_CLUSTERS"  ]; then
39                 nls "Warning: there are no configured clusters."
40                 nls "Using default cluster /var/lib/mysql (compatibility mode)"
41                 MYSQL_DB_CLUSTERS=/var/lib/mysql
42         fi
43 fi
44
45
46 # Check that networking is up
47 if is_yes "${NETWORKING}"; then
48         if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status -a "$1" != init ]; then
49                 msg_network_down MySQL
50                 exit 1
51         fi
52 else
53         exit 0
54 fi
55
56 action="$1"
57
58 # any db cluster as command line argument?
59 if [ $# -gt 1 ]; then
60         shift
61         # perform action for specified clusters only
62         for a in "$@"; do
63                 # try auto resolving from /etc/mysql/clusters.conf
64                 if [[ "$a" != /* ]]; then
65                         m=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $1}' /etc/mysql/clusters.conf)
66                         if [ -z "$m" ]; then
67                                 echo >&2 "Cluster name '$a' did not match anything!"
68                                 exit 1
69                         fi
70                         if [ $(echo "$m" | wc -l) -gt 1 ]; then
71                                 echo >&2 "Cluster name '$a' ambiguous:" $m
72                                 exit 1
73                         fi
74                         a=$(awk -va="$a" -F= 'substr($0, 1, length(a)) == a {print $2}' /etc/mysql/clusters.conf)
75                 fi
76                 DB_CLUSTERS="$DB_CLUSTERS $a"
77         done
78 else
79         DB_CLUSTERS="$MYSQL_DB_CLUSTERS"
80 fi
81
82 # global error log, if mysqld.conf hasn't migrated to log-error style
83 MYSQL_ERRLOG=/var/log/mysql/mysqld.log
84 MYSQL_STOP_WAIT_TIME=${MYSQL_STOP_WAIT_TIME:-900}
85
86 #
87 # Useful functions.
88 #
89
90 #
91 # check for mysql status
92 #
93 # arguments:
94 # $1 - db cluster
95 # $2 - start|stop
96 #
97 # sets variables:
98 # MYSQL_STATUS = starting | running | not running | died
99 # MYSQL_PID    = pid of mysqld process
100 #
101 mysqlstatus() {
102         clusterdir="$1"
103         mode="$2"
104         
105         mysqlgetconfig "$clusterdir"
106
107         MYSQL_STATUS="not running"
108         MYSQL_PID="unknown"
109         MYSQL_PIDFILE_PID=""
110         MYSQL_GREP_PID=""
111
112         if [ -f "$MYSQL_PIDFILE" ]; then
113                 MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
114         fi
115         
116         if [ -n "$MYSQL_PIDFILE_PID" ]; then
117                 MYSQL_PID=$MYSQL_PIDFILE_PID
118                 if [ ! -d "/proc/$MYSQL_PID" ]; then
119                         MYSQL_STATUS="died"
120                         return
121                 elif (grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null); then
122                         MYSQL_STATUS="running"
123                         return
124                 fi
125         fi
126
127         if [ "$mode" = "start" ]; then
128                 MYSQL_GREP_PID=$(grep -lE "^/usr/sbin/mysqld.*${MYSQL_PIDFILE}" /proc/[0-9]*/cmdline 2> /dev/null | awk -F "/" '{ print $3; exit; }')
129                 if [ -n "$MYSQL_GREP_PID" ]; then
130                         MYSQL_PID=$MYSQL_GREP_PID
131                         if grep -qa "$MYSQL_PIDFILE" /proc/$MYSQL_PID/cmdline 2> /dev/null; then
132                                 if [ -f "$MYSQL_PIDFILE" ]; then
133                                         MYSQL_PIDFILE_PID=$(cat "$MYSQL_PIDFILE")
134                                 fi
135                                 if [ -n "$MYSQL_PIDFILE_PID" ]; then
136                                         MYSQL_PID=$MYSQL_PIDFILE_PID
137                                         MYSQL_STATUS="running"
138                                         return
139                                 else
140                                         MYSQL_STATUS="starting"
141                                         return
142                                 fi
143                         fi
144                 fi
145         fi
146
147         # else default, "not running"
148 }
149
150 # get mysql configuration in variables
151 # MYSQL_CONFIG MYSQL_CLUSTER_DIR
152 # MYSQL_DATA_DIR MYSQL_USER MYSQL_PIDFILE MYSQL_SOCKET MYSQL_PORT MYSQL_BIND_ADDRESS MYSQL_SKIP_NETWORKING MYSQL_LOG_ERROR
153 #
154 # arguments
155 # $1 - db cluster
156
157 mysqlgetconfig() {
158         local clusterdir="$1" config_file
159
160         # emulate old behaviour if only one cluster specified
161         if [ "$clusterdir" = "$MYSQL_DB_CLUSTERS" -a "$clusterdir" = "/var/lib/mysql" -a -f /etc/mysqld.conf ]; then
162                 MYSQL_RA_COMPAT=yes
163                 config_file=/etc/mysqld.conf
164         else
165                 local config=$(awk -F= -vclusterdir="$clusterdir" '!/^#/{ if (clusterdir == $2) print $1}' /etc/mysql/clusters.conf)
166                 if [[ $config = /* ]]; then
167                         config_file="$config"
168                 elif [ -f "/etc/mysql/$config" ]; then
169                         config_file="/etc/mysql/$config"
170                 else
171                         config_file="$clusterdir/mysqld.conf"
172                 fi
173         fi
174
175         MYSQL_CLUSTER_DIR="$clusterdir"
176
177         if [ -z "$config_file" ]; then
178                 nls "Error: Can't find config file for %s cluster" "$clusterdir"
179                 exit 6
180         else
181                 MYSQL_CONFIG="$config_file"
182         fi
183
184         if [ ! -f "$config_file" ]; then
185                 nls "Error: config file %s not found" "$config_file"
186                 nls "MySQL can't be run. Did you initialize DB by doing \`$0 init'?"
187                 exit 6
188         fi
189
190         # reset to initial state
191         MYSQL_DATA_DIR= MYSQL_USER= MYSQL_PIDFILE= MYSQL_SOCKET= MYSQL_PORT= MYSQL_BIND_ADDRESS= MYSQL_SKIP_NETWORKING= MYSQL_LOG_ERROR=
192
193         eval `awk -F= '
194         {
195                 # undos
196                 gsub(/\r$/, "");
197
198                 # trim spaces
199                 gsub(/^[\t ]+|[\t ]+$/, "", $1);
200                 gsub(/^[\t ]+|[\t ]+$/, "", $2);
201         }
202
203         # skip comments and empty lines
204         /^[;#]|^ *$/ { next }
205
206         /^[ \t]*\[.*\][ \t]*$/ {
207                 match($0, /\[.*\]/);
208                 section = substr($0, RSTART + 1, RSTART + RLENGTH - 3);
209                 next;
210         }
211
212         section == "mysqld" {
213                 if ($1 == "datadir") {
214                         printf("MYSQL_DATA_DIR=%s;", $2);
215                 } else if ($1 == "user") {
216                         printf("MYSQL_USER=%s;", $2);
217                 } else if ($1 == "pid-file") {
218                         printf("MYSQL_PIDFILE=%s;", $2);
219                 } else if ($1 == "socket") {
220                         printf("MYSQL_SOCKET=%s;", $2);
221                 } else if ($1 == "port") {
222                         printf("MYSQL_PORT=%s;", $2);
223                 } else if ($1 == "bind-address") {
224                         printf("MYSQL_BIND_ADDRESS=%s;", $2);
225                 } else if ($1 == "skip-networking") {
226                         printf("MYSQL_SKIP_NETWORKING=1;");
227                 } else if ($1 == "log-error") {
228                         printf("MYSQL_LOG_ERROR=%s;", $2);
229                 }
230         }
231         ' $config_file`
232
233         # error log not defined in config file. add one
234         if [ -z "$MYSQL_LOG_ERROR" ]; then
235                 MYSQL_LOG_ERROR=$MYSQL_ERRLOG
236         else
237                 # unset, so mysqld would use value from config itself
238                 unset MYSQL_LOG_ERROR
239         fi
240
241         if is_yes "$MYSQL_RA_COMPAT"; then
242                 MYSQL_DATA_DIR_SUB=""
243         else
244                 MYSQL_DATA_DIR_SUB="/mysqldb"
245         fi
246
247         if [ -z "$MYSQL_DATA_DIR" -o "$MYSQL_DATA_DIR" != "${clusterdir}${MYSQL_DATA_DIR_SUB}/db" ]; then
248                 nls "Error: datadir specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/db"
249                 nls " MySQL can't be run."
250                 exit 6
251         fi
252
253         if [ -z "$MYSQL_PIDFILE" -o "$MYSQL_PIDFILE" != "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid" ]; then
254                 nls "Error: pid-file specified in %s should be %s" "$config_file" "$clusterdir${MYSQL_DATA_DIR_SUB}/mysql.pid"
255                 nls " MySQL can't be run."
256                 exit 6
257         fi
258
259         if [ -z "$MYSQL_USER" ]; then
260                 echo "$(nls 'MySQL user not configured properly')"'!' >&2
261                 nls "Edit %s and configure it." "$config_file" >&2
262                 exit 6
263         fi
264 }
265
266 # start mysql
267 mysqlstart() {
268         local clusterdir="$1"
269         mysqlgetconfig "$clusterdir"
270         if [ ! -d "$MYSQL_DATA_DIR/mysql" ]; then
271                 nls "MySQL cluster %s not initialized." "$clusterdir"
272                 nls "Try \`%s init %s' before start." "$0" "$clusterdir"
273                 exit 6
274         fi
275
276         msg_starting "MySQL $clusterdir"; busy
277         [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
278         rm -f "$MYSQL_PIDFILE"
279
280
281         TMPDIR=/tmp nice -n ${SERVICE_RUN_NICE_LEVEL:-$DEFAULT_SERVICE_RUN_NICE_LEVEL} \
282                 /usr/bin/setsid /usr/sbin/mysqld \
283                         --defaults-file=$MYSQL_CONFIG \
284                         --datadir=$MYSQL_DATA_DIR \
285                         --pid-file=$MYSQL_PIDFILE \
286                         ${MYSQL_LOG_ERROR:+--log-error="$MYSQL_LOG_ERROR"} \
287                         $MYSQL_OPTIONS &
288         pid=$!
289
290         sleep 0.1
291         mysqlstatus "$clusterdir" start
292         # it takes longer for mysqld to start and create pidfile if it has to recover innodb transactions
293         if [ "$MYSQL_STATUS" = "starting" ]; then
294                 echo ""
295                 show "Waiting for MySQL to start"
296                 busy
297
298                 # while the pid is running, mysql is starting up
299                 # if the pidfile was created, it started up successfully
300                 # if either case fails we break and report status
301                 while true; do
302                         [ -d /proc/$pid ] || break
303                         [ -f "$MYSQL_PIDFILE" ] && break
304                         sleep 0.2
305                 done
306         fi
307
308         mysqlstatus "$clusterdir" start
309         if [ "$MYSQL_STATUS" = "running" -a "$MYSQL_PID" != "unknown" ]; then
310                 ok
311         elif [ "$MYSQL_STATUS" = "died" ]; then
312                 RETVAL=1
313                 died
314         else
315                 RETVAL=1
316                 fail
317         fi
318 }
319
320 # stop mysql
321 mysqlstop() {
322         local clusterdir="$1"
323         mysqlstatus "$clusterdir" stop
324         msg_stopping "MySQL $clusterdir"
325         busy
326
327         # try graceful shutdown -- send shutdown command
328         # requires mysql_sysadmin user proper privs
329         /usr/bin/mysqladmin --defaults-file=$MYSQL_CONFIG ${MYSQL_SOCKET:+--socket=$MYSQL_SOCKET} shutdown >/dev/null 2>&1
330         mysqlstatus "$clusterdir" stop
331
332         if [ "$MYSQL_PID" != "unknown" ]; then
333                 kill -TERM "$MYSQL_PID" 2> /dev/null
334                 for nr in $(seq 1 $(($MYSQL_STOP_WAIT_TIME*10))); do
335                         [ -d "/proc/$MYSQL_PID" ] || break
336                         sleep 0.1
337                 done
338         fi
339         
340         mysqlstatus "$clusterdir" stop
341         if [ "$MYSQL_STATUS" = "died" ]; then
342                 died
343         elif [ "$MYSQL_STATUS" = "running" -o "$MYSQL_STATUS" = "starting" ]; then
344                 fail
345         else
346                 ok
347         fi
348 }
349
350 #
351 # check for running mysql instances; if any instance is running then
352 # create subsys lock file
353 #
354 mysqlsubsys() {
355         # check for every defined db cluster in sysconfig file
356         for mysqldir in $DB_CLUSTERS; do
357                 mysqlstatus "$mysqldir"
358                 if [ "$MYSQL_STATUS" = "running" ]; then
359                         touch /var/lock/subsys/mysql
360                         return
361                 fi
362         done
363         rm -f /var/lock/subsys/mysql
364 }
365
366 mysqlinit() {
367         local clusterdir="$1"
368
369         if [ -f /etc/mysqld.conf ]; then
370                 nls "Running in \`no cluster compat' mode: can't initialize database."
371                 nls "Move /etc/mysqld.conf away and rerun \`$0 init' (new config will be in $clusterdir)."
372                 exit 1
373         fi
374
375         if [ -f "$clusterdir/mysqld.conf" ]; then
376                 mysqlgetconfig "$clusterdir"
377         else
378                 MYSQL_USER="mysql"
379                 MYSQL_CLUSTER_DIR="$clusterdir"
380                 MYSQL_DATA_DIR="$clusterdir/mysqldb/db"
381                 MYSQL_PIDFILE="$clusterdir/mysqldb/mysql.pid"
382                 MYSQL_SOCKET="$clusterdir/mysqldb/mysql.sock"
383
384                 # this $MYSQL_CONFIG will be created later
385                 MYSQL_CONFIG="$MYSQL_CLUSTER_DIR/mysqld.conf"
386         fi
387
388         show "Initializing cluster %s" "$clusterdir"; started
389
390         # Check if not exist init database
391         if [ -d "$MYSQL_DATA_DIR/mysql" ]; then
392                 nls "Seems that database is initialized now. Remove by hand %s" "$MYSQL_DATA_DIR/mysql"
393                 nls "before initializing database."
394                 nls "For now skipping cluster %s." "$clusterdir"
395                 return
396         fi
397
398         show "Installing MySQL system tables for $MYSQL_DATA_DIR"
399         busy
400         TMP=/tmp TMPDIR=/tmp
401
402         mkdir -p "$MYSQL_DATA_DIR" > /dev/null 2>&1
403         # Using mysql:mysql for MYSQL_CLUSTER_DIR is creating SECURITY hole, root:root is proper
404         chown root:root "$MYSQL_CLUSTER_DIR"
405         chown mysql:mysql "$MYSQL_CLUSTER_DIR/mysqldb" "$MYSQL_DATA_DIR" > /dev/null 2>&1
406         chmod 751 "$MYSQL_CLUSTER_DIR" "$MYSQL_CLUSTER_DIR/mysqldb"
407
408         if [ -f /usr/share/mysql/mysqld.conf -a ! -f "$MYSQL_CLUSTER_DIR/mysqld.conf" ]; then
409             sed -e "
410                 s#\(datadir.*\)=.*#\1= $MYSQL_DATA_DIR#g;
411                 s#\(pid-file.*\)=.*#\1= $MYSQL_PIDFILE#g;
412                 s#\(socket.*\)=.*#\1= $MYSQL_SOCKET#g;
413                 s#@clusterdir@#$MYSQL_CLUSTER_DIR#g;
414                 " /usr/share/mysql/mysqld.conf > "$MYSQL_CLUSTER_DIR/mysqld.conf"
415             chown root:root "$MYSQL_CLUSTER_DIR/mysqld.conf"
416             chmod 640 "$MYSQL_CLUSTER_DIR/mysqld.conf"
417         fi
418
419         if [ ! -e /var/lib/mysql/mysql.sock ] || [ -L /var/lib/mysql/mysql.sock ] && [ -z "$(readlink /var/lib/mysql/mysql.sock)" ]; then
420                 sock=${MYSQL_SOCKET#/var/lib/mysql/} # make it relative if possible
421             ln -s "$sock" /var/lib/mysql/mysql.sock
422         fi
423
424         cat > $MYSQL_DATA_DIR/mysql-init.sql <<-EOF
425                 CREATE DATABASE mysql;
426                 use mysql;
427                 $(cat /usr/share/mysql/mysql_system_tables.sql)
428                 $(sed -e "/@current_hostname/d" /usr/share/mysql/mysql_system_tables_data.sql)
429 EOF
430
431         ok=0
432         /usr/sbin/mysqld \
433                 --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
434                 --bootstrap \
435                 --skip-grant-tables \
436                 --datadir=$MYSQL_DATA_DIR \
437                 --user=$MYSQL_USER \
438                 --slave-load-tmpdir=$MYSQL_DATA_DIR \
439                 --tmpdir=$MYSQL_DATA_DIR \
440                 --log-error=$MYSQL_ERRLOG \
441                 < $MYSQL_DATA_DIR/mysql-init.sql && ok=1
442         [ -f $MYSQL_DATA_DIR/mysql/host.frm ] || ok=0
443
444         if [ "$ok" = 1 ]; then
445                 rm -f $MYSQL_DATA_DIR/mysql-init.sql
446                 ok
447                 cat << END_OF_MSG
448
449 PLEASE REMEMBER TO SET A PASSWORD FOR THE MySQL USERS!
450 This is done, after starting database, in the order shown,
451 with:
452
453 For 'mysql_sysadmin' (RELOAD and SHUTDOWN privileges):
454 echo "update mysql.user set password=password('newpassword') where user='mysql_sysadmin'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
455
456 For 'mysql' user (ALL privileges, DB admin):
457 echo "update mysql.user set password=password('newpassword') where user='mysql'; FLUSH PRIVILEGES;" | mysql -u mysql -S $MYSQL_SOCKET
458
459 NOTE: mysql_sysadmin password should be placed to $MYSQL_CONFIG in
460 mysqladmin section. See the manual for more instructions.
461 (This user is used at logs rotation and server shutdown)
462
463 END_OF_MSG
464                 show "Filling help tables..."
465                 ok=0
466                 ( echo "use mysql;"; cat /usr/share/mysql/fill_help_tables.sql ) | \
467                         /usr/sbin/mysqld \
468                         --defaults-file=$MYSQL_CLUSTER_DIR/mysqld.conf \
469                         --bootstrap \
470                         --skip-grant-tables \
471                         --datadir=$MYSQL_DATA_DIR \
472                         --user=$MYSQL_USER \
473                         --slave-load-tmpdir=$MYSQL_DATA_DIR \
474                         --tmpdir=$MYSQL_DATA_DIR \
475                         --log-error=$MYSQL_ERRLOG \
476                         && ok=1
477                 if [ "$ok" = 1 ]; then
478                         ok
479                 else
480                         cat << END_OF_MSG
481
482 WARNING: HELP FILES ARE NOT COMPLETELY INSTALLED!
483 The "HELP" command might not work properly.
484
485 END_OF_MSG
486                 fi
487         else
488                 fail
489                 cat << END_OF_MSG
490 Installation of grant tables FAILED!
491
492 The initialization SQL script was preserved at $MYSQL_DATA_DIR/mysql-init.sql
493
494 Examine the logs in /var/log/mysql for more information.  You can
495 also try to start the mysqld daemon with:
496
497 /usr/sbin/mysqld --skip-grant &
498
499 You can use the command line tool mysql to connect to the mysql
500 database and look at the grant tables:
501
502 shell> mysql -u mysql mysql
503 mysql> show tables
504
505 Try 'mysqld --help' if you have problems with paths. Setting on
506 logging in $MYSQL_DATA_DIR/mysqld.conf gives you a log in /var/log/mysql/query.log that
507 may be helpful. The latest information about MySQL is available on the
508 web at http://www.mysql.com/.
509
510 Please check PLD Linux ftp site for newer versions of this package.
511
512 Please consult the MySQL manual section: 'Problems running
513 mysql_install_db', and the manual section that describes problems on
514 your OS.  Another information source is the MySQL email archive.
515
516 END_OF_MSG
517                 exit 1
518         fi
519 }
520
521 #
522 # End of useful functions.
523 #
524
525 start() {
526         local mysqldir
527         for mysqldir in $DB_CLUSTERS; do
528                 mysqlstatus "$mysqldir" start
529                 if [ "$MYSQL_STATUS" = "running" ]; then
530                         msg_already_running "MySQL $mysqldir"
531                 else
532                         mysqlstart "$mysqldir"
533                 fi
534         done
535         mysqlsubsys
536 }
537
538 stop() {
539         local mysqldir
540         for mysqldir in $DB_CLUSTERS; do
541                 mysqlstatus "$mysqldir" stop
542                 if [ "$MYSQL_STATUS" = "not running" ]; then
543                         msg_not_running "MySQL $mysqldir"
544                 else
545                         mysqlstop "$mysqldir"
546                 fi
547         done
548         mysqlsubsys
549 }
550
551 condrestart() {
552         if [ ! -f /var/lock/subsys/mysql ]; then
553                 msg_not_running "MySQL"
554                 RETVAL=$1
555                 return
556         fi
557
558         stop
559         start
560 }
561
562 RETVAL=0
563 case "$action" in
564   start)
565         start
566         ;;
567   stop)
568         stop
569         ;;
570   restart)
571         stop
572         start
573         ;;
574   try-restart)
575         condrestart 0
576         ;;
577   force-reload)
578         condrestart 7
579         ;;
580   init)
581         for mysqldir in $DB_CLUSTERS; do
582                 mysqlinit "$mysqldir"
583         done
584         exit $?
585         ;;
586   flush-logs)
587         for mysqldir in $DB_CLUSTERS; do
588             mysqlgetconfig "$mysqldir"
589                 # just if mysqld is really running
590                 if /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" ping >/dev/null 2>&1; then
591                         /usr/bin/mysqladmin --defaults-file="$MYSQL_CONFIG" --socket="$MYSQL_SOCKET" flush-logs
592                 fi
593         done
594         ;;
595   status)
596         for mysqldir in $DB_CLUSTERS; do
597                 mysqlstatus "$mysqldir"
598                 if [ "$MYSQL_STATUS" = "running" ]; then
599                         addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
600                         port=${MYSQL_PORT:-3306}
601                         socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
602                         pid=$MYSQL_PID
603                         nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
604                         [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
605                         nls "\tunix:%s\n" "$socket"
606                         pids="$pids/$MYSQL_PID/"
607                         progress "$MYSQL_STATUS"
608                 else
609                         show "MySQL cluster %s" "$mysqldir"
610                         progress "$MYSQL_STATUS" "$CFAIL"
611                 fi
612                 echo
613         done
614
615         for pid in $(/sbin/pidof mysqld); do
616                 if [[ $pids != */$pid/* ]]; then
617                         running="$running $pid"
618                 fi
619         done
620
621         if [ $# = 1 -a "$running" ]; then
622                 nls "Warning: MySQL Daemon processes not under clusters.conf control:"
623                 # see if we can display their status
624                 for pid in $running; do
625                         datadir=$(cat /proc/$pid/cmdline | tr '\0' '\n' | fgrep -- --datadir=)
626                         datadir=${datadir#--datadir=} # strip --datadir
627                         mysqldir=${datadir%/mysqldb/db} # strip /mysqldb/db
628                         mysqlstatus "$mysqldir"
629                         if [ "$MYSQL_STATUS" = "running" ]; then
630                                 addr=${MYSQL_BIND_ADDRESS:-0.0.0.0}
631                                 port=${MYSQL_PORT:-3306}
632                                 socket=${MYSQL_SOCKET:-/var/lib/mysql/mysql.sock}
633                                 nls "MySQL cluster %s, pid %s\n" "$mysqldir" "$pid"
634                                 [ -z "$MYSQL_SKIP_NETWORKING" ] && nls "\ttcp:%s:%s\n" "$addr" "$port"
635                                 nls "\tunix:%s\n" "$socket"
636                                 progress "$MYSQL_STATUS"
637                         else
638                                 show "MySQL cluster %s" "$mysqldir"
639                                 progress "$MYSQL_STATUS" "$CFAIL"
640                         fi
641                         echo
642                 done
643         fi
644         ;;
645   *)
646         msg_usage "$0 {start|stop|restart|try-restart|force-reload|init|flush-logs|status}"
647         exit 3
648 esac
649
650 exit $RETVAL
This page took 0.071339 seconds and 3 git commands to generate.